package com.ruoyi.oa.service;

import com.ruoyi.common.core.domain.R;
import com.ruoyi.oa.domain.vo.OaSalaryVo;
import com.ruoyi.oa.domain.bo.OaSalaryBo;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;

import javax.validation.constraints.NotBlank;
import java.util.Collection;
import java.util.Date;
import java.util.List;

/**
 * 薪资管理Service接口
 *
 * @author hdka
 * @date 2025-03-06
 */
public interface IOaSalaryService {

    /**
     * 查询薪资管理
     */
    OaSalaryVo queryById(Long salaryId, @NotBlank Date payTime);

    /**
     * 查询薪资管理列表
     */
    TableDataInfo<OaSalaryVo> queryPageList(OaSalaryBo bo, PageQuery pageQuery);

    /**
     * 查询薪资管理列表
     */
    List<OaSalaryVo> queryList(OaSalaryBo bo);

    /**
     * 新增薪资管理
     */
    Boolean insertByBo(OaSalaryBo bo);

    /**
     * 修改薪资管理
     */
    Boolean updateByBo(OaSalaryBo bo);

    /**
     * 校验并批量删除薪资管理信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);


    /**
     * 计算工资
     *
     * @param bo
     * @return
     */
    String calcSalary(OaSalaryBo bo);

    /**
     * 导入当月所有人的记录
     * @return
     */
    R<Void> importSalaryUser(Date payTime);

    TableDataInfo<OaSalaryVo> listWorker(OaSalaryBo bo, PageQuery pageQuery);
}
